<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link href="https://fonts.googleapis.com/css?family=Cutive|Work+Sans" rel="stylesheet">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.1/normalize.min.css">
  <title>Autosave</title>
  <style type="text/css">
    /**
     * Add box sizing to everything
     * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
     */
    *,
    *:before,
    *:after {
      box-sizing: border-box;
    }

    /**
     * Layout
     */
    body {
      font-family: 'Work Sans', sans-serif; sans-serif;
      margin-left: auto;
      margin-right: auto;
      max-width: 40em;
      width: 88%;
    }
    /**
		 * Forms
		 */
		[type="text"],
		[type="email"],
		select,
		textarea {
			display: block;
			margin-bottom: 1em;
			width: 100%;
		}

		textarea {
			height: 8em;
		}

		label {
			display: block;
			font-weight: bold;
			margin-bottom: 0.25em;
		}

		.label-plain {
			font-weight: normal;
		}
    button:hover { cursor: pointer;}
  </style>
</head>
<body>

	<h1>Autosave</h1>

	<form class="save-me" id="save-me">

		<label for="name">Name</label>
		<input type="text" name="name" id="name">

		<label for="address">Address</label>
		<input type="text" name="address" id="address">

		<label for="email">Email</label>
		<input type="email" name="email" id="email">

		<label for="hear-about-us">How did you hear about us?</label>
		<select name="hear-about-us" id="hear-about-us">
			<option value=""></option>
			<option value="google">Google</option>
			<option value="referral">Referred by a Friend</option>
			<option value="tv">A TV Ad</option>
			<option value="radio">A Radio Ad</option>
		</select>

		<label id="more">Additional thoughts?</label>
		<textarea name="more" id="more"></textarea>

		<p><strong>Do you agree to our terms of service?</strong></p>
		<label class="label-plain">
			<input type="radio" name="tos" value="yes">
			Yes
		</label>
		<label class="label-plain">
			<input type="radio" name="tos" value="no">
			No
		</label>

		<p><strong>Pick your favorite super heros.</strong></p>

		<label class="label-plain">
			<input type="checkbox" name="spiderman">
			Spiderman
		</label>

		<label class="label-plain">
			<input type="checkbox" name="wonderwoman">
			Wonder Woman
		</label>

		<label class="label-plain">
			<input type="checkbox" name="blackpanther">
			Black Panther
		</label>

		<div style="padding-top: 1rem;">
      <button type="submit">Submit</button>
    </div>

	</form>


	<script>
  (function () {

    const forms = document.querySelectorAll('form');
    let storedData = []

    // Listen for click event for now
    document.addEventListener('input', function(e) {
      Array.from(forms).forEach(form => {
        if (e.target.matches('form input, form select')) {
          storedData.push({
            name: e.target.name,
            value: e.target.value
          })
        }
      })

      localStorage.setItem('formData', JSON.stringify(storedData))
    }, false);

    // Do I have to do this?
    document.addEventListener('focusout', function(e) {

      Array.from(forms).forEach(form => {
        if (e.target.matches('form textarea')) {
          storedData.push({
            name: e.target.name,
            value: e.target.value
          })
        }
      })

      localStorage.setItem('formData', JSON.stringify(storedData))
    }, false);

    document.addEventListener('submit', function(e) {
      localStorage.clear()
    });


    let parsed = JSON.parse(localStorage.getItem('formData'));

    if (parsed) {

      console.log(parsed);

      Object.values(parsed).forEach((v, i) => {

        Array.from(forms).forEach(form => {

          let field = form.elements[i];

          if (field.type !== 'checkbox' && field.type !=='radio' && field.name == v.name) {
            field.value = v.value
          }

          if (field.type == 'radio' && field.name == v.name) {
            field.checked = true
          }

          // Not presently working
          if (field.type == "checkbox" && field.name == v.name) {
            field.checked = true
          }

        })
      })

    }

  })()

	</script>

</body>
</html>
